# docker_loki-grafana

1、安装docker

docker pull grafana/loki:latest
docker run -d --name loki -p 3100:3100 grafana/loki:latest

docker pull grafana/promtail:latest
创建一个配置文件promtail-config.yaml
server:
 http_listen_port: 9080
 grpc_listen_port: 0
positions:
 filename: /tmp/positions.yaml
clients:
 - url: http://loki:3100/loki/api/v1/push
scrape_configs:
- job_name: flog_scrape_config
 static_configs:
 - targets:
     - localhost
   labels:
     job: varlogs
     __path__: /var/log/*log

使用以下命令运行Promtail Docker容器，挂载配置文件和日志文件目录：

docker run -d --name promtail \
 -v /path/to/your/logs:/var/log \  
 -v /path/to/promtail-config.yaml:/etc/promtail/promtail-config.yaml \  
 grafana/promtail:latest \
 -config.file=/etc/promtail/promtail-config.yaml

将/path/to/your/logs替换为实际包含日志文件的目录路径，以及/path/to/promtail-config.yaml替换为你的配置文件路径

安装Grafana
docker pull grafana/grafana:latest
docker run -d --name=grafana -p 3000:3000 grafana/grafana:latest
配置Grafana以使用Loki作为数据源
打开Grafana的Web界面 http://localhost:3000
登录
添加Loki作为数据源
在Grafana侧边栏中选择“Connections”  > “Data sources”（数据源）。
点击“Add data source”（添加数据源）。
选择“Loki”作为类型。
设置URL为http://loki:3100  (两个容器内有挂在同一个docker虚拟网络上)
设置URL为http://host.docker.internal:3100 (两个容器内不在同一个docker虚拟网络上)

开启docker的插件功能
执行命令docker安装loki插件
docker plugin install grafana/loki-docker-driver:latest --alias loki --grant-all-permissions

查看插件情况
docker plugin ls


Docker修改配置发送日志到loki
{
    "debug" : true,
    "log-driver": "loki",
    "log-opts": {
        "loki-url": "http://127.0.0.1:3100/loki/api/v1/push",
        "loki-batch-size": "400"
    }
}
重启docker

启动测试容器查看日志




